/***************************************************************************
                          block.h  -  description
                             -------------------
    begin                : Fri Feb 11 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BLOCK_H
#define BLOCK_H

#include "codegenerator.h"

/**
  *@author Ivan Martinez
  */

//#include "variableinput.h"

class CLoop;

class CBlock : public CCodeGenerator {
public:
	CBlock();
	virtual ~CBlock();
  /**  */
  virtual bool AcceptsContainer(const CCodeGenerator*);
  /**  */
  virtual bool CandidateForOrdenation(const CCodeGeneratorPointers&) const;
  /**  */

  /**  */
  const CLoop* Container() const;
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  const string& Name() const;
  /**  */
  virtual bool RepeatedValue(const CCodeGenerator*, const string&, const string&) const;
  /**  */
  bool SetName(const string&);
  /**  */

protected:
  /**  */
  virtual void Arrange(void* = NULL);
  /**  */
  virtual void ComponentsDependingArrange(void* = NULL);
  /**  */
  virtual void GenerateCall(ostream&, void* = NULL) const;
private: // Private attributes
  /**  */
  string NameA;
};

#endif
