/***************************************************************************
                          derivablevector.h  -  description
                             -------------------
    begin                : Fri May 12 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DERIVABLEVECTOR_H
#define DERIVABLEVECTOR_H

/**
  *@author Ivan Martinez
  */

#include <vector>


template <class Type>
class TDerivableVector {
public:
  /**  */
  typedef vector<Type>::iterator Iterator;
  /**  */
  typedef vector<Type>::const_iterator ConstIterator;
	/**  */
	TDerivableVector();
  /**  */
	virtual ~TDerivableVector();
  /**  */
  void Append(const TDerivableVector<Type>&);
  /**  */
  ConstIterator Begin() const;
  /**  */
  Iterator Begin();
  /**  */
  void Clear();
	/**  */
  bool Empty() const;
  /**  */
  ConstIterator End() const;
  /**  */
  Iterator End();
  /**  */
  void PushBack(Type);
  /**  */
  unsigned int Size() const;
  /**  */
  Type operator[](unsigned int);
  /**  */
  Type operator[](unsigned int) const;
protected:
  /**  */
  vector<Type> m_Vector;
};

#include "derivablevector.cpp"

#endif
