/***************************************************************************
                          dynamicsystem.h  -  description
                             -------------------
    begin                : Thu Feb 10 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DYNAMICSYSTEM_H
#define DYNAMICSYSTEM_H

#include "rtmodule.h"

/**
  *@author Ivan Martinez
  */

#include "function.h"
#include <time.h>
#include <vector>
#include <string>
#include "loop.h"
#include "variable.h"

class CDynamicSystem : public CRTModule {
public:
	CDynamicSystem();
  /**  */
	virtual ~CDynamicSystem();
  /**  */
  virtual bool AcceptsContainer(const CCodeGenerator*);
  /**  */
  bool ArrangeAll(void* = NULL);
  /**  */
  virtual string Class() const;
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&,
		void* = NULL) const;
  /**  */
  virtual void GenerateSource(ostream&, void* = NULL) const;
  /**  */
  bool SetTime(long long);
  /**  */
	long long Time() const;
protected:
  /**  */

private: // Private attributes
  /**  */
  long long m_llTime;
};

#endif
