/***************************************************************************
                          functioninput.cpp  -  description
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "functioninput.h"

#include "loop.h"

CFunctionInput::CFunctionInput()
{
}
CFunctionInput::~CFunctionInput()
{
}
/**  */
string CFunctionInput::Class() const
{
	return "CFunctionInput";
}
/**  */
bool CFunctionInput::SetName(const string& NameL)
{
	SetLocalIdentifier(NameL);

	if (IllegalCIdentifier(NameL))
	{
		AddError(600);
		return false;
	}	
	else
		return true;
}
/**  */
bool CFunctionInput::DescendantOf(const string& ClassNameL) const
{
	if (ClassNameL == "CFunctionInput")
		return true;
	else
		return CInput::DescendantOf(ClassNameL);
}
/**  */
void CFunctionInput::Arrange(void* ExtraParameterL = NULL)
{
	if (IllegalCIdentifier(LocalIdentifier()))
		AddError(600);
	else
		if (Connected())
			SetIdentifier("iovar_" + Container()->Container()->Identifier() + "_" +
				ConnectedOutput()->Container()->Name() + "_" + ConnectedOutput()->LocalIdentifier());
		else
			AddError(1400);
}
/**  */
void CFunctionInput::GenerateCode(ostream& StreamL, const CCodeGenerator* CallerPL,
	const string& SectionL, void* ExtraParameterL = NULL) const
{
	if (CallerPL->DescendantOf("CFunction"))
	{
		if (SectionL == "initialized variables declaration")
			GenerateInitializationDeclaration(StreamL, ExtraParameterL);
		else
			if (SectionL == "variables initialization")
				GenerateInitialization(StreamL, ExtraParameterL);
			else
				if (SectionL == "initialized variables writing")
					GenerateInitializationWriting(StreamL, ExtraParameterL);
				else
					if (SectionL == "local declarations")
						GenerateLocalDeclarations(StreamL, ExtraParameterL);
					else			
						if (SectionL == "inputs reading")
							GenerateGlobalReading(StreamL, ExtraParameterL);
	}
}
/**  */
bool CFunctionInput::SetType(const string& Type)
{
	CVariable::SetType(Type);

	if (IllegalCIdentifier(Type))
	{
		AddError(602);
		return false;
	}	
	else
	{
		return true;
	}
}
/**  */
bool CFunctionInput::SetInitialization(const string& Initialization)
{
	CInitializableVariable::SetInitialization(Initialization);

	return true;
}
/**  */
bool CFunctionInput::AcceptsContainer(const CCodeGenerator* pContainer)
{
	if (pContainer->DescendantOf("CFunction"))
	{
		SetContainer(pContainer);
		return true;
	}
	else
	{
		AddError(101);
		return false;
	}
}
/**  */
const CFunction* CFunctionInput::Container() const
{
	return (CFunction*) CCodeGenerator::Container();
}
/**  */
const string& CFunctionInput::Name() const
{
	return LocalIdentifier();
}
