/***************************************************************************
                          functioninput.h  -  description
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FUNCTIONINPUT_H
#define FUNCTIONINPUT_H

#include "input.h"

/**
  *@author Ivan Martinez
  */

#include "loggingfifo.h"
#include "function.h"

class CBlock;

class CFunctionInput : public CInput {
public:
	CFunctionInput();
	~CFunctionInput();
  /**  */
  virtual bool AcceptsContainer(const CCodeGenerator*);
  /**  */
  virtual string Class() const;
  /**  */
  const CFunction* Container() const;
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  const string& Name() const;
  /**  */
  bool SetInitialization(const string&);
  /**  */
  bool SetName(const string&);
  /**  */
  bool SetType(const string&);
protected:
  /**  */
	virtual void Arrange(void* = NULL);
  /**  */
  virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&,
		void* = NULL) const;
};

#endif
