/***************************************************************************
                          initializablevariable.h  -  description
                             -------------------
    begin                : Mon Jun 5 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INITIALIZABLEVARIABLE_H
#define INITIALIZABLEVARIABLE_H

#include "variable.h"

/**
  *@author Ivan Martinez
  */

class CInitializableVariable : public CVariable  {
public:
	CInitializableVariable();
	~CInitializableVariable();
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  const string& Initialization() const;
  /**  */
  bool Initialized() const;
protected:
	/**  */
  virtual void GenerateInitialization(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateInitializationDeclaration(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateInitializationWriting(ostream&, void* = NULL) const;
  /**  */
  void SetInitialization(const string&);
private: // Private attributes
  /**  */
  string InitializationA;
};

#endif
