/***************************************************************************
                          loggingfifo.h  -  description
                             -------------------
    begin                : Tue May 23 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LOGGINGFIFO_H
#define LOGGINGFIFO_H

#include "variablefifo.h"

/**
  *@author Ivan Martinez
  */

class CVariable;

class CLoggingFifo : public CVariableFifo  {
public:
	CLoggingFifo();
	virtual ~CLoggingFifo();
  /**  */
  virtual bool AcceptsContainer(const CCodeGenerator*);
  /**  */
  virtual string Class() const;
  /**  */
  const CVariable* Container() const;
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  virtual unsigned int MaximumInComponents() const;
  /**  */
  unsigned int Number() const;
  /**  */
  bool SetNumber(unsigned int);
  /**  */
  int Size() const;
  /**  */
  bool SetSize(int);
protected:
  /**  */
  virtual void Arrange(void* = NULL);
  /**  */
  virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&, void* = NULL) const;
  /**  */
  virtual void GenerateLockedFifoWriting(ostream&, void* = NULL) const;
};

#endif
