/***************************************************************************
                          loop.h  -  description
                             -------------------
    begin                : Thu Feb 10 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LOOP_H
#define LOOP_H

#include "rttask.h"

/**
  *@author Ivan Martinez
  */

#include "function.h"
#include <time.h>
#include "loopvariable.h"
#include <iostream>
#include "reportingfifo.h"

class CDynamicSystem;

class CLoop : public CRTTask {
public:
	CLoop();
  /**  */
	~CLoop();
  /**  */
  virtual bool AcceptsContainer(const CCodeGenerator*);
  /**  */
  virtual string Class() const;
  /**  */
	const CDynamicSystem* Container() const;
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  bool FloatingPoint() const;
  /**  */
  unsigned int IRQNumber() const;
  /**  */
  const string& Name() const;
  /**  */
  long long Period() const;
  /**  */
  unsigned int Priority() const;
  /**  */
  virtual bool RepeatedValue(const CCodeGenerator*, const string&, const string&) const;
  /**  */
  bool SetFloatingPoint(bool);
  /**  */
  bool SetScheduling(SchedulingE);
  /**  */
  bool SetIRQNumber(unsigned int);
  /**  */
  bool SetName(const string&);
  /**  */
  bool SetPeriod(long long);
  /**  */
  bool SetPriority(unsigned int);
protected:
  /**  */
  virtual void Arrange(void* = NULL);
  /**  */
  virtual void ComponentsDependingArrange(void* = 0);
  /**  */
  virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&,
		void* = NULL) const;
  /**  */
  virtual void GenerateCode(CStringsSet&, const CCodeGenerator*, const string&,
		void* = NULL) const;
  /**  */
  virtual void GenerateFunctions(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateInitializationCall(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateInitializationFunctions(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateSuspend(ostream&, void* = NULL) const;
};

#endif
