/***************************************************************************
                          loopvariable.cpp  -  description
                             -------------------
    begin                : Thu Mar 23 2000
    copyright            : (C) 2000 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "loopvariable.h"

#include "loop.h"

CLoopVariable::CLoopVariable()
{
}
CLoopVariable::~CLoopVariable()
{
}
/**  */
void CLoopVariable::Arrange(void* ExtraParameterL = NULL)
{
	if (IllegalCIdentifier(LocalIdentifier()))
		AddError(600);
	else
		SetIdentifier("loopvar_" + Container()->Identifier() + "_" + LocalIdentifier());
}
/**  */
string CLoopVariable::Class() const
{
	return "CLoopVariable";
}
/**  */
void CLoopVariable::GenerateCode(ostream& StreamL, const CCodeGenerator* CallerPL,
	const string& SectionL, void* ExtraParameterL = 0) const
{
	if (CallerPL->DescendantOf("CDynamicSystem"))
	{
		if (SectionL == "global variables declaration")
			GenerateGlobalDeclarations(StreamL, ExtraParameterL);
	}
	else
		if (CallerPL->DescendantOf("CLoop"))
		{
			if (SectionL == "initialized variables declaration")
				GenerateInitializationDeclaration(StreamL, ExtraParameterL);
			else
				if (SectionL == "variables initialization")
					GenerateInitialization(StreamL, ExtraParameterL);
				else
					if (SectionL == "initialized variables writing")
						GenerateInitializationWriting(StreamL, ExtraParameterL);
		}
		else
			if (CallerPL->DescendantOf("CBlock"))
				if (SectionL == "local loop variable declarations")
					GenerateLocalDeclarations(StreamL, ExtraParameterL);
				else			
					if (SectionL == "loop variables reading")
						GenerateGlobalReading(StreamL, ExtraParameterL);
					else
						if (SectionL == "loop variables writing")
							GenerateGlobalWriting(StreamL, ExtraParameterL);
}
/**  */
bool CLoopVariable::SetName(const string& NameL)
{
	SetLocalIdentifier(NameL);

	if (IllegalCIdentifier(NameL))
	{
		AddError(600);
		return false;
	}	
	else
	{
		return true;
	}
}
/**  */
bool CLoopVariable::DescendantOf(const string& ClassNameL) const
{
	if (ClassNameL == "CLoopVariable")
		return true;
	else
		return CInitializableVariable::DescendantOf(ClassNameL);
}
/**  */
bool CLoopVariable::SetInitialization(const string& InitializationL)
{
	CInitializableVariable::SetInitialization(InitializationL);

	return true;
}
/**  */
const CLoop* CLoopVariable::Container() const
{
	return (CLoop*)CInitializableVariable::Container();
}
/**  */
bool CLoopVariable::SetType(const string& Type)
{
	CVariable::SetType(Type);

	if (IllegalCIdentifier(Type))
	{
		AddError(602);
		return false;
	}	
	else
		return true;
}
/**  */
bool CLoopVariable::AcceptsContainer(const CCodeGenerator* pContainer)
{
	if (pContainer->DescendantOf("CLoop"))
	{
		SetContainer(pContainer);
		return true;
	}
	else
	{
		AddError(101);
		return false;
	}
}
/**  */
const string& CLoopVariable::Name() const
{
	return LocalIdentifier();
}
