/***************************************************************************
                          loopvariable.h  -  description
                             -------------------
    begin                : Thu Mar 23 2000
    copyright            : (C) 2000 by 
    email                : ivan_m_r@email.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LOOPVARIABLE_H
#define LOOPVARIABLE_H

#include "initializablevariable.h"

/**
  *@author Ivan Martinez
  */

#include "loggingfifo.h"
#include "settingfifo.h"

class CLoop;

class CLoopVariable : public CInitializableVariable {
public:
	CLoopVariable();
	~CLoopVariable();
  /**  */
  virtual bool AcceptsContainer(const CCodeGenerator*);
  /**  */
  virtual string Class() const;
  /**  */
  const CLoop* Container() const;
  /**  */
  virtual bool DescendantOf(const string&) const;
  /**  */
  const string& Name() const;
  /**  */
  bool SetInitialization(const string&);
  /**  */
  bool SetName(const string&);
  /**  */
  bool SetType(const string&);
protected:
  /**  */
	virtual void Arrange(void* = NULL);
  /**  */
  virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&,
		void* = NULL) const;
};

#endif
